from datetime import datetime

from cpl_core.database import TableABC


class TechnicianPingUrlConfig(TableABC):
    def __init__(
        self,
        ping_url: str,
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._ping_url = ping_url

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def id(self) -> int:
        return self._id

    @property
    def ping_url(self) -> str:
        return self._ping_url

    @ping_url.setter
    def ping_url(self, value: str):
        self._ping_url = value

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
                SELECT * FROM `CFG_TechnicianPingUrls`;
            """
        )

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(
            f"""
                SELECT * FROM `CFG_TechnicianPingUrls`
                WHERE `Id` = {id};
            """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
                INSERT INTO `CFG_TechnicianPingUrls` (
                    `URL`
                ) VALUES (
                    '{self._ping_url}'
                );
            """
        )

    @property
    def udpate_string(self) -> str:
        return str(
            f"""
                UPDATE `CFG_TechnicianPingUrls`
                SET `URL` = '{self._ping_url}'
                WHERE `Id` = {self._id};
            """
        )

    @property
    def delete_string(self) -> str:
        return str(
            f"""
                DELETE FROM `CFG_TechnicianPingUrls`
                WHERE `URL` = '{self._ping_url}';
            """
        )
