from datetime import datetime

from bot_data.abc.history_table_abc import HistoryTableABC


class UserJoinedGameServerHistory(HistoryTableABC):
    def __init__(
        self,
        user: int,
        game_server: int,
        joined_on: datetime,
        leaved_on: datetime,
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)

        self._id = id
        self._user = user
        self._game_server = game_server
        self._joined_on = joined_on
        self._leaved_on = leaved_on

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def id(self) -> int:
        return self._id

    @property
    def user(self) -> int:
        return self._user

    @property
    def game_server(self) -> int:
        return self._game_server

    @property
    def time(self) -> float:
        if self._leaved_on is None or self._joined_on is None:
            return 0
        return round((self.leaved_on - self.joined_on).total_seconds() / 3600, 2)

    @property
    def joined_on(self) -> datetime:
        return self._joined_on

    @property
    def leaved_on(self) -> datetime:
        return self._leaved_on
